#include <iostream>
#include <cstdlib>
#include <vector>

#include <TApplication.h>
#include <TASImage.h>
#include <TCanvas.h>
#include <TClass.h>
#include <TColor.h>
#include <TEllipse.h>
#include <TFrame.h>
#include <TGFrame.h>
#include <TGLayout.h>
#include <TGTableLayout.h>
#include <TMath.h>
#include <TQObject.h>
#include <TRootEmbeddedCanvas.h>
#include <TSystem.h>


class MyTASImage: public TASImage, public TQObject {
public:
	MyTASImage(const TASImage &img) : TASImage(img) {};
	virtual ~MyTASImage(){};

	void	UnZoom();														// *MENU*
	void	Zoom(UInt_t offX, UInt_t offY, UInt_t width, UInt_t height);	// *MENU*
	void	Zoomed();														// *SIGNAL*

	ClassDef(MyTASImage, 1)
};


class MyMainFrame : public TGMainFrame {
private:
	std::vector<TRootEmbeddedCanvas*>	fEmbCanvasVec;
	UInt_t								fH, fW, fCols, fRows;
	MyTASImage							*fImg;
	TEllipse							*fEll;

public:
	MyMainFrame(const TGWindow *p, UInt_t w, UInt_t h, UInt_t rows = 2, UInt_t cols = 2);
	virtual ~MyMainFrame(){};

	virtual void						CloseWindow();
	virtual void						GUIResized();
	virtual void						ImageZoomed();
	virtual void						ResizePad(UInt_t canvasIndex);
	ClassDef(MyMainFrame, 1)
};
